/*
    A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class HD_Frame extends Frame {
    Socket socket;
    String User_ID,
           UID,
           data,
           CurQuery;
    Vector vdata;
    int Cur_selected=-1;
    databaseListener databaselistener = null;
    StringBuffer sb;
    
    public void addOk(boolean flag) {
        HD_A_button1.enable(flag);
    }
    
	void HDSHTreeView_Action(Event event) {
		HD_SH_problem.setText("This is to show that you've selected : " 
		    + HD_SH_treeView.getSelectedText());
		HD_SH_solution.setText("And this is the solution to the problem of : "
		    + HD_SH_treeView.getSelectedText());
	}

	void HDSMultiList1_KeyPress(Event event) {
		if (User_ID.startsWith("User")) {
		    return;
		} else {
    	    int i = HD_S_multiList1.getSelectedRow();
    		HD_S_multiList1.setSelectedRow(i);	
        	vdata = databaselistener.processRequest("HELPDESK_CALLLOG_DELETE " + String.valueOf(HD_S_multiList1.getCellText(i,0)));
        	doLoad(CurQuery);
	    }
	}

	void HDSRadioButton1_Action(Event event) {
		doLoad("all");
	}

	void HDSRadioButton2_Action(Event event) {
		doLoad("unassigned");
	}

	void HDSRadioButton3_Action(Event event) {
		doLoad("mine");
	}

	void HDSRadioButton4_Action(Event event) {
		doLoad("completed");
	}
  
	void HDSMultiList1_Action(Event event) {    
	    int i = HD_S_multiList1.getSelectedRow();
		HD_S_multiList1.setSelectedRow(i);	
// System.out.println("MLA: CS=" + String.valueOf(Cur_selected) + "   i=" + String.valueOf(i));
	    if (Cur_selected != i) {
        	(new HD_Frame1(String.valueOf(HD_S_multiList1.getCellText(i,0))+","+User_ID, databaselistener, this)).show();
        }
        Cur_selected = i;
	}

	void HDAbutton1_Clicked(Event event) {
        HD_A_button1.enable(false);
		(new HD_Frame1("add" + "," + User_ID, databaselistener, this)).show();
	}
	
	void setPosition() {
	    Cur_selected = -2;
// System.out.println("SP: CS=" + String.valueOf(Cur_selected));
    }

	void doLoad(String action) {
   
        CurQuery = action;
        
	    HD_S_multiList1.clear();
	    
	    if (action.equalsIgnoreCase("all")) { 
            vdata = databaselistener.processRequest("HELPDESK_CALLINFO_QUERY 1| ");
	    }
	    else if (action.equalsIgnoreCase("unassigned"))  { 
            vdata = databaselistener.processRequest("HELPDESK_CALLINFO_QUERY 2| ");
	    }
	    else if (action.equalsIgnoreCase("mine"))  { 
            vdata = databaselistener.processRequest("HELPDESK_CALLINFO_QUERY 3|" + UID);
	    }
	    else if (action.equalsIgnoreCase("completed"))  { 
            vdata = databaselistener.processRequest("HELPDESK_CALLINFO_QUERY 4| ");
	    }	        
	    
	    int s = vdata.size() -1;
	    for (int i=0; i<s; i++) {
	        StringTokenizer st = new StringTokenizer((String )vdata.elementAt(i), "|");
	        int j = st.countTokens();
            for (int x=0; x<j; x++)
                 HD_S_multiList1.addTextCell(i, x, st.nextToken());
        }
        if (HD_S_multiList1.getCellText(0,0).startsWith("WARNING"))
            HD_S_multiList1.clear();
        HD_S_multiList1.redraw();
	}

	public HD_Frame(String title) {

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 640,insets().top + insets().bottom + 480);
		setBackground(new Color(12632256));
		HDT_Panel = new symantec.itools.awt.TabPanel();
		HDT_Panel.setLayout(null);
		HDT_Panel.reshape(insets().left + 0,insets().top + 0,640,480);
		HDT_Panel.setFont(new Font("Dialog", Font.BOLD, 12));
		add(HDT_Panel);
		{
			java.lang.String[] tempString = new java.lang.String[4];
			tempString[0] = new java.lang.String("Help");
			tempString[1] = new java.lang.String("Add a Call");
			tempString[2] = new java.lang.String("Self Help");
			tempString[3] = new java.lang.String("Search Calls");
			HDT_Panel.setPanelLabels(tempString);
		}
		HDP_Help = new symantec.itools.awt.KeyPressManagerPanel();
		HDP_Help.setLayout(null);
		HDP_Help.reshape(12,33,616,436);
		HDT_Panel.add(HDP_Help);
		HD_H_Label1 = new java.awt.Label("Welcome to the NDP HelpDesk System.    Brought to you by your friendly MIS Team.");
		HD_H_Label1.reshape(8,7,600,25);
		HDP_Help.add(HD_H_Label1);
		HD_H_list1 = new java.awt.List(0,false);
		HDP_Help.add(HD_H_list1);
		HD_H_list1.reshape(8,37,600,390);
		HD_H_list1.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_H_list1.setBackground(new Color(16777215));
		HDP_Add = new symantec.itools.awt.KeyPressManagerPanel();
		HDP_Add.setLayout(null);
		HDP_Add.reshape(12,33,616,436);
		HDT_Panel.add(HDP_Add);
		HD_A_button1 = new java.awt.Button("Click Here to Add a Call");
		HD_A_button1.reshape(133,107,350,80);
		HD_A_button1.setFont(new Font("Dialog", Font.BOLD, 20));
		HDP_Add.add(HD_A_button1);
		HDP_SelfHelp = new symantec.itools.awt.KeyPressManagerPanel();
		HDP_SelfHelp.setLayout(null);
		HDP_SelfHelp.reshape(12,33,616,436);
		HDT_Panel.add(HDP_SelfHelp);
		HD_SH_problem = new java.awt.TextArea();
		HD_SH_problem.setEditable(false);
		HD_SH_problem.reshape(193,117,415,120);
		HDP_SelfHelp.add(HD_SH_problem);
		HD_SH_solution = new java.awt.TextArea();
		HD_SH_solution.setEditable(false);
		HD_SH_solution.reshape(193,282,415,120);
		HDP_SelfHelp.add(HD_SH_solution);
		HD_SH_treeView = new symantec.itools.awt.TreeView();
		HD_SH_treeView.reshape(8,92,175,335);
		HD_SH_treeView.setBackground(new Color(16777215));
		HDP_SelfHelp.add(HD_SH_treeView);
		{
			java.lang.String[] tempString = new java.lang.String[17];
			tempString[0] = new java.lang.String("Software");
			tempString[1] = new java.lang.String(" Office");
			tempString[2] = new java.lang.String(" Win95");
			tempString[3] = new java.lang.String(" MFGpro");
			tempString[4] = new java.lang.String("  Colours");
			tempString[5] = new java.lang.String("  Keyboard");
			tempString[6] = new java.lang.String("Hardware");
			tempString[7] = new java.lang.String(" Printer");
			tempString[8] = new java.lang.String(" Screen");
			tempString[9] = new java.lang.String("  Flickering");
			tempString[10] = new java.lang.String(" Keyboard");
			tempString[11] = new java.lang.String("  Sticking");
			tempString[12] = new java.lang.String("  Coffee");
			tempString[13] = new java.lang.String(" Disk Drive");
			tempString[14] = new java.lang.String(" Noises");
			tempString[15] = new java.lang.String("  Screen");
			tempString[16] = new java.lang.String("  Disk Driver");
			HD_SH_treeView.setTreeStructure(tempString);
		}
		HD_SH_label1 = new java.awt.Label("To search, use either the 'Key Words' or the 'Problem Tree'.");
		HD_SH_label1.reshape(13,12,495,20);
		HDP_SelfHelp.add(HD_SH_label1);
		HD_SH_label2 = new java.awt.Label("Problem Tree:",Label.RIGHT);
		HD_SH_label2.reshape(8,67,115,20);
		HDP_SelfHelp.add(HD_SH_label2);
		HD_SH_label3 = new java.awt.Label("Key Words:",Label.RIGHT);
		HD_SH_label3.reshape(213,42,95,20);
		HDP_SelfHelp.add(HD_SH_label3);
		HD_SH_label4 = new java.awt.Label("Problem:",Label.RIGHT);
		HD_SH_label4.reshape(193,97,80,20);
		HDP_SelfHelp.add(HD_SH_label4);
		HD_SH_label5 = new java.awt.Label("Solution:",Label.RIGHT);
		HD_SH_label5.reshape(193,262,80,20);
		HDP_SelfHelp.add(HD_SH_label5);
		HD_SH_keyword1 = new java.awt.TextField();
		HD_SH_keyword1.reshape(318,42,95,20);
		HDP_SelfHelp.add(HD_SH_keyword1);
		HD_SH_keyword2 = new java.awt.TextField();
		HD_SH_keyword2.reshape(413,42,95,20);
		HDP_SelfHelp.add(HD_SH_keyword2);
		HD_SH_button3 = new java.awt.Button("Search");
		HD_SH_button3.reshape(533,42,65,24);
		HDP_SelfHelp.add(HD_SH_button3);
		HD_SH_button1 = new java.awt.Button("Prev <<");
		HD_SH_button1.reshape(318,72,65,24);
		HDP_SelfHelp.add(HD_SH_button1);
		HD_SH_button2 = new java.awt.Button("Next >>");
		HD_SH_button2.reshape(398,72,65,24);
		HDP_SelfHelp.add(HD_SH_button2);
		HDP_Search = new symantec.itools.awt.KeyPressManagerPanel();
		HDP_Search.setLayout(null);
		HDP_Search.reshape(12,33,616,436);
		HDT_Panel.add(HDP_Search);
		HD_S_label1 = new java.awt.Label("Search by:",Label.CENTER);
		HD_S_label1.reshape(8,17,100,25);
		HDP_Search.add(HD_S_label1);
		Group1 = new CheckboxGroup();
		HD_S_radioButton1 = new java.awt.Checkbox("All Calls", Group1, true);
		HD_S_radioButton1.reshape(113,17,85,25);
		HDP_Search.add(HD_S_radioButton1);
		HD_S_radioButton2 = new java.awt.Checkbox("Unassigned", Group1, false);
		HD_S_radioButton2.reshape(203,17,105,25);
		HDP_Search.add(HD_S_radioButton2);
		HD_S_radioButton3 = new java.awt.Checkbox("My Calls", Group1, false);
		HD_S_radioButton3.reshape(318,17,85,25);
		HDP_Search.add(HD_S_radioButton3);
		HD_S_radioButton4 = new java.awt.Checkbox("Completed", Group1, false);
		HD_S_radioButton4.reshape(408,17,100,25);
		HDP_Search.add(HD_S_radioButton4);
		HD_S_multiList1 = new symantec.itools.awt.MultiList();
		HD_S_multiList1.reshape(13,47,590,375);
		HDP_Search.add(HD_S_multiList1);
		{
			java.lang.String[] tempString = new java.lang.String[5];
			tempString[0] = new java.lang.String("Log No");
			tempString[1] = new java.lang.String("Date");
			tempString[2] = new java.lang.String("Priority");
			tempString[3] = new java.lang.String("Name");
			tempString[4] = new java.lang.String("Problem");
			HD_S_multiList1.setHeadings(tempString);
		}
		{
			java.lang.String[] tempString = new java.lang.String[5];
			tempString[0] = new java.lang.String("60");
			tempString[1] = new java.lang.String("75");
			tempString[2] = new java.lang.String("55");
			tempString[3] = new java.lang.String("150");
			tempString[4] = new java.lang.String("250");
			HD_S_multiList1.setColumnSizes(tempString);
		}
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		//}}
		setTitle(title);
	    Dimension dim = getToolkit().getScreenSize();
        Rectangle abounds = bounds();
        Dimension dd = size();
        move((dim.width - abounds.width) / 2,
         (dim.height - abounds.height) / 2);

        HD_H_list1.addItem("");
        HD_H_list1.addItem("As a user of the HelpDesk System you will be able to view your own calls and");
        HD_H_list1.addItem("add new ones for the Support Staff to act upon.");
        HD_H_list1.addItem("");
        HD_H_list1.addItem("You can also use the Self-Help area to view past requests to find a solution");
        HD_H_list1.addItem("to your problem without adding a new call. Use this first as it will save everyone");
        HD_H_list1.addItem("time & effort.");
        HD_H_list1.addItem("");
        HD_H_list1.addItem("To add a new call; select the 'Add a Call' tab & press the button. If you enter your");
        HD_H_list1.addItem("FULL Phone number it will fill in any details it already knows about you to save you");
        HD_H_list1.addItem("time. Complete the form and please take note of the Log No it gives as you will need");
        HD_H_list1.addItem("it later on to quote to Support Staff or in reviewing your call yourself.");
        HD_H_list1.addItem("");
        HD_H_list1.addItem("To see what's happening with your call, select the 'Search Calls' tab and you'll");
        HD_H_list1.addItem("see a list appear. Using the Log No given to you earlier just double-click on the");
        HD_H_list1.addItem("appropriate line and you'll see all the details about your call. If it's not in the");
        HD_H_list1.addItem("list then it has probably been completed & you should contact the HelpDesk.");
        HD_H_list1.addItem("");
	}

	public HD_Frame(String title, Socket socket) {
	    this("NDP Help Desk System: User = " + title);
        
//        HDT_Panel.showTabPanel(3);
//        setTitle("NDP Help Desk System: User = " + title);
	    User_ID = title;
        StringTokenizer st = new StringTokenizer(title, "/");
        UID = st.nextToken().toLowerCase();
	    
        databaselistener = new databaseListener(socket);
	    
		if (User_ID.startsWith("User")) {
   		    HDP_Search.remove(HD_S_radioButton2);
   		    HDP_Search.remove(HD_S_radioButton3);
   		    HDP_Search.remove(HD_S_radioButton4);
		}
        doLoad("all");	    
	}
	
    public synchronized void show() {
//    	move(50, 50);
    	super.show();
    }

	public boolean handleEvent(Event event) {
    	if (event.target == this && event.id == Event.WINDOW_DESTROY) {
    	    databaselistener.processRequest("quit");
    	    this.hide();
    	    System.exit(0);
			return true;
    	}
		if (event.target == HD_A_button1 && event.id == Event.ACTION_EVENT) {
			HDAbutton1_Clicked(event);
			return true;
		}
		if (event.target == HD_S_multiList1 && event.id == Event.ACTION_EVENT) {
			HDSMultiList1_Action(event);
			return true;
		}
		if (event.target == HD_S_radioButton1 && event.id == Event.ACTION_EVENT) {
			HDSRadioButton1_Action(event);
			return true;
		}
		if (event.target == HD_S_radioButton2 && event.id == Event.ACTION_EVENT) {
			HDSRadioButton2_Action(event);
			return true;
		}
		if (event.target == HD_S_radioButton3 && event.id == Event.ACTION_EVENT) {
			HDSRadioButton3_Action(event);
			return true;
		}
		if (event.target == HD_S_radioButton4 && event.id == Event.ACTION_EVENT) {
			HDSRadioButton4_Action(event);
			return true;
		}
		if (event.target == HD_SH_treeView && event.id == Event.ACTION_EVENT) {
			HDSHTreeView_Action(event);
			return true;
		}

		if (event.target == HD_S_multiList1 && event.id == Event.KEY_PRESS && event.key == 127) {
			HDSMultiList1_KeyPress(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	symantec.itools.awt.TabPanel HDT_Panel;
	symantec.itools.awt.KeyPressManagerPanel HDP_Help;
	java.awt.Label HD_H_Label1;
	java.awt.List HD_H_list1;
	symantec.itools.awt.KeyPressManagerPanel HDP_Add;
	java.awt.Button HD_A_button1;
	symantec.itools.awt.KeyPressManagerPanel HDP_SelfHelp;
	java.awt.TextArea HD_SH_problem;
	java.awt.TextArea HD_SH_solution;
	symantec.itools.awt.TreeView HD_SH_treeView;
	java.awt.Label HD_SH_label1;
	java.awt.Label HD_SH_label2;
	java.awt.Label HD_SH_label3;
	java.awt.Label HD_SH_label4;
	java.awt.Label HD_SH_label5;
	java.awt.TextField HD_SH_keyword1;
	java.awt.TextField HD_SH_keyword2;
	java.awt.Button HD_SH_button3;
	java.awt.Button HD_SH_button1;
	java.awt.Button HD_SH_button2;
	symantec.itools.awt.KeyPressManagerPanel HDP_Search;
	java.awt.Label HD_S_label1;
	java.awt.Checkbox HD_S_radioButton1;
	CheckboxGroup Group1;
	java.awt.Checkbox HD_S_radioButton2;
	java.awt.Checkbox HD_S_radioButton3;
	java.awt.Checkbox HD_S_radioButton4;
	symantec.itools.awt.MultiList HD_S_multiList1;
	//}}

	//{{DECLARE_MENUS
	//}}
}
