/*
    A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Date;

public class HD_Frame1 extends Frame {
	void HDDRemove_Clicked(Event event) {
        vdata = databaselistener.processRequest("HELPDESK_CALLLOG_DELETE " + HDD_LogNo.getText());	    
		hide();
	}

    String Action,
           User_ID,
           UID,
           Today_Date,
           data;
    StringBuffer sb;       
    Vector vdata = new Vector();
           
    boolean Phone_Add = false,
            Record_Changed = false;
            
    databaseListener databaselistener;
    
    HD_Frame parent;
             
	void HDDCancel_Clicked(Event event) {
	    vdata = databaselistener.processRequest("helpdesk_calllog_delete ");
		hide();
	}
/*	
	public String parseData(String line, String find, String repl) {
	    String out = new String();
	    
	    int i=0, j=0, len1 = find.length();
	    
	    if (line.indexOf(find) == -1)
	        return line;
	 
	    while ((i = line.indexOf(find)) != -1) {
	        out = out.concat(line.substr(j, i-1) + repl);
	    }
	    
	    return out;
	}
*/	
	public String getTime() {
	    vdata = databaselistener.processRequest("helpdesk_time_query X|");
	    data = (String )vdata.elementAt(0);
	    data = data.replace('\174', '\040');
	    return data.trim();
	}

	public String getDate() {
	    vdata = databaselistener.processRequest("helpdesk_date_query X|");
	    data = (String )vdata.elementAt(0); 
	    data = data.replace('\174', '\040');
	    return data.trim();
	}

	void HDDPriority_Action(Event event) {
	    if (HDD_Priority.getSelectedItem().equals("1 Urgent")) {
		    new messageDialog(this, "Are you Sure about this Priority", 
		        "Urgent Priority is for SYSTEM DOWN").show();
		}
	}

	void HDFrame1_Exit(Event event) {
	     	    
	    parent.setPosition();
	    
	    if (HDD_Problem.getText().length() < 1)
	        HDD_Problem.setText(" ");
	        
	    if (Action.equals("Query")) {
/*            data = HDD_LogNo.getText() + "|" + HDD_Priority.getSelectedItem() + "|" + HDD_ProbType1.getSelectedItem()
	               + "|" + HDD_Status.getSelectedItem() + "|" + HDD_Problem.getText() + "|" + HDD_Solution.getText()
	               + "|" + HDD_AS_Date.getText() + "|" + HDD_AS_Time.getText() + "|" + HDD_AS_Whom.getText()
	               + "|" + HDD_Assigned.getSelectedItem() + "|" + HDD_CO_Date.getText() + "|" + HDD_CO_Time.getText()
	               + "|" + HDD_CO_Whom.getText() + "|";  */
	        data = new StringBuffer().append(HDD_LogNo.getText()).append("|").append(HDD_Priority.getSelectedItem()).append("|").append(HDD_ProbType1.getSelectedItem())
	               .append("|").append(HDD_Status.getSelectedItem()).append("|").append(HDD_Problem.getText()).append("|").append(HDD_Solution.getText())
	               .append("|").append(HDD_AS_Date.getText()).append("|").append(HDD_AS_Time.getText()).append("|").append(HDD_AS_Whom.getText())
	               .append("|").append(HDD_Assigned.getSelectedItem()).append("|").append(HDD_CO_Date.getText()).append("|").append(HDD_CO_Time.getText())
	               .append("|").append(HDD_CO_Whom.getText()).append("|").toString();
            vdata = databaselistener.processRequest("HELPDESK_CALLLOG_UPDATE " + data);
    		hide();
    		data = (String )vdata.elementAt(0);
            if (data.startsWith("ERROR")) {
                (new HD_ErrorDialog(this, data, true)).show();
            }
        }
        else {
	        String logno = new String();
	        vdata = databaselistener.processRequest("HELPDESK_CALLNO_QUERY ");
	        data = (String )vdata.elementAt(1);
            if (data.startsWith("OK")) {
                logno = (String )vdata.elementAt(0);
        	    logno = logno.replace('\174', '\040');
        	    logno = logno.trim();
        	}
            else {
                (new HD_ErrorDialog(this, data, true)).show();
                this.hide();
                return;
            }
  	        parent.addOk(true);
/*            data = HDD_Phone.getText() + "|" + HDD_Priority.getSelectedItem() + "|" + 
                    HDD_ProbType1.getSelectedItem() + "|" +  HDD_Status.getSelectedItem() + "|" +
                    HDD_Assigned.getSelectedItem() + "|" + HDD_Problem.getText() + "|" + HDD_TB_Whom.getText() + "|"; */
            data = new StringBuffer().append(logno).append("|").append(HDD_Phone.getText()).append("|").append(HDD_Priority.getSelectedItem())
                    .append("|").append(HDD_ProbType1.getSelectedItem()).append("|").append(HDD_Status.getSelectedItem()).append("|")
                    .append(HDD_Assigned.getSelectedItem()).append("|").append(HDD_Problem.getText()).append("|")
                    .append(HDD_TB_Whom.getText()).toString();
            data = data.replace('\015', '\040');
            data = data.replace('\012', '\040');
       		hide();
	        vdata = databaselistener.processRequest("HELPDESK_CALLLOG_ADD " + data);
    		data = (String )vdata.elementAt(0);
            if (data.startsWith("OK")) {
        		(new messageDialog(this, "Adding Call Details", "Your Log No is: " + logno)).show();
        		if (Phone_Add) {
                    vdata = databaselistener.processRequest("HELPDESK_PHONE_ADD " + HDD_Phone.getText());
                }
            }
        	else {
                (new HD_ErrorDialog(this, data, true)).show();
                this.hide();
            }
            parent.doLoad("all");
        }
	}

	void HDDPhone_LostFocus(Event event) {
	    String nm = new String(HDD_FirstName.getText()),
	           sm = new String(HDD_Surname.getText());

        if (HDD_Phone.getText().length() < 10) {
            (new HD_ErrorDialog(this, "You must complete the Phone No. Field", true)).show();
            HDD_Phone.requestFocus();
        }
        
	    if (nm.length() == 0 && sm.length() == 0) {
            vdata = databaselistener.processRequest("HELPDESK_PHONE_QUERY " + HDD_Phone.getText());
    		data = (String )vdata.elementAt(0);
            if (data.startsWith("WARNING") || data.startsWith("ERROR")) {
               Phone_Add = true;
            }
            else {
                StringTokenizer st = new StringTokenizer(data, "|");
    	        HDD_FirstName.setText(st.nextToken());
    	        HDD_Surname.setText(st.nextToken());
    	        HDD_Site.setText(st.nextToken());
            }
	    }
	}

	void HDDStatus_Action(Event event) {
	    String nw = new String(HDD_AS_Whom.getText()),
	           cow = new String(HDD_CO_Whom.getText());
	           
	    String time = new String(getTime());

	    if (HDD_Status.getSelectedItem().equals("New") && nw.length() == 0) {
    		HDD_TB_Whom.setText(User_ID);
            HDD_TB_Time.setText(time);
            HDD_TB_Date.setText(Today_Date);
        }
	    else if (HDD_Status.getSelectedItem().equals("Assigned")) {
    		HDD_AS_Whom.setText(User_ID);
            HDD_AS_Time.setText(time);
            HDD_AS_Date.setText(Today_Date);
        }
	    else if (HDD_Status.getSelectedItem() == "Completed" && cow.length() < 5) {
	        if (HDD_TB_Whom.getText().equals(User_ID) || (! User_ID.startsWith("User"))) {
        		HDD_CO_Whom.setText(User_ID);
                HDD_CO_Time.setText(time);
                HDD_CO_Date.setText(Today_Date);
            }
            else {
                (new HD_ErrorDialog(this, "Naughty person ... You can't to this", true)).show();
            }    
        }
	}

	void HDDAssigned_Action(Event event) {
	    String time = new String(getTime());
	    
	    if ( ! User_ID.startsWith("User")) {
            HDD_AS_Date.setText(Today_Date);
            HDD_AS_Time.setText(time);
            HDD_AS_Whom.setText(User_ID);
        }
        if (HDD_Status.getSelectedItem().equals("New"))
            HDD_Status.select("Assigned");
	}

	public HD_Frame1() {

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 616,insets().top + insets().bottom + 436);
		setBackground(new Color(12632256));
		HD_Details = new symantec.itools.awt.KeyPressManagerPanel();
		HD_Details.setLayout(null);
		HD_Details.reshape(insets().left + 0,insets().top + 0,616,436);
		HD_Details.setBackground(new Color(12632256));
		add(HD_Details);
		HDD_LogNo = new java.awt.TextField();
		HDD_LogNo.setEditable(false);
		HDD_LogNo.reshape(85,0,55,20);
		HDD_LogNo.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_LogNo.setBackground(new Color(12632256));
		HD_Details.add(HDD_LogNo);
		label1 = new java.awt.Label(" Log No",Label.RIGHT);
		label1.reshape(20,0,65,20);
		label1.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label1);
		HDD_Phone = new symantec.itools.awt.FormattedTextField();
		HDD_Phone.reshape(85,25,115,20);
		HDD_Phone.setBackground(new Color(65280));
		HD_Details.add(HDD_Phone);
		HDD_Phone.setMask("/(99/)/ 9999/ 9999");
		label3 = new java.awt.Label("Phone",Label.RIGHT);
		label3.reshape(25,25,60,20);
		label3.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label3);
		HDD_FirstName = new java.awt.TextField();
		HDD_FirstName.reshape(85,50,125,20);
		HDD_FirstName.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_FirstName.setBackground(new Color(16777215));
		HD_Details.add(HDD_FirstName);
		label2 = new java.awt.Label(" FirstName",Label.RIGHT);
		label2.reshape(0,50,85,20);
		label2.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label2);
		label7 = new java.awt.Label(" Surname",Label.RIGHT);
		label7.reshape(10,70,75,20);
		label7.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label7);
		HDD_Surname = new java.awt.TextField();
		HDD_Surname.reshape(85,70,125,20);
		HDD_Surname.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_Surname.setBackground(new Color(16777215));
		HD_Details.add(HDD_Surname);
		label8 = new java.awt.Label(" Site",Label.RIGHT);
		label8.reshape(10,90,75,20);
		label8.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label8);
		HDD_Site = new java.awt.TextField();
		HDD_Site.reshape(85,90,125,20);
		HDD_Site.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_Site.setBackground(new Color(16777215));
		HD_Details.add(HDD_Site);
		label5 = new java.awt.Label(" Problem Type:",Label.RIGHT);
		label5.reshape(215,0,115,20);
		label5.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label5);
		HDD_ProbType1 = new java.awt.Choice();
		HDD_ProbType1.addItem("Hardware");
		HDD_ProbType1.addItem("Software");
		try {
			HDD_ProbType1.select(0);
		} catch (IllegalArgumentException e) {
		}
		HD_Details.add(HDD_ProbType1);
		HDD_ProbType1.reshape(335,0,100,20);
		HDD_ProbType1.setBackground(new Color(16777215));
		label4 = new java.awt.Label(" Priority",Label.RIGHT);
		label4.reshape(450,0,65,20);
		label4.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label4);
		HDD_Priority = new java.awt.Choice();
		HDD_Priority.addItem("1 Urgent");
		HDD_Priority.addItem("2 High");
		HDD_Priority.addItem("3 Medium");
		HDD_Priority.addItem("4 Low");
		try {
			HDD_Priority.select(2);
		} catch (IllegalArgumentException e) {
		}
		HD_Details.add(HDD_Priority);
		HDD_Priority.reshape(520,0,90,20);
		HDD_Priority.setBackground(new Color(16777215));
		label13 = new java.awt.Label(" Status",Label.RIGHT);
		label13.reshape(450,50,65,20);
		label13.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label13);
		HDD_Status = new java.awt.Choice();
		HDD_Status.addItem("New");
		HDD_Status.addItem("Assigned");
		HDD_Status.addItem("Completed");
		try {
			HDD_Status.select(0);
		} catch (IllegalArgumentException e) {
		}
		HD_Details.add(HDD_Status);
		HDD_Status.reshape(520,50,90,20);
		HDD_Status.setBackground(new Color(16777215));
		HDD_Problem = new java.awt.TextArea(5,80);
		HDD_Problem.reshape(10,135,600,90);
		HDD_Problem.setBackground(new Color(16777215));
		HD_Details.add(HDD_Problem);
		HDD_Solution = new java.awt.TextArea(5,80);
		HDD_Solution.reshape(10,245,600,90);
		HDD_Solution.setBackground(new Color(16777215));
		HD_Details.add(HDD_Solution);
		label17 = new java.awt.Label(" Assigned To",Label.RIGHT);
		label17.reshape(405,90,110,20);
		label17.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label17);
		HDD_Assigned = new java.awt.Choice();
		HDD_Assigned.addItem(" ");
		HDD_Assigned.addItem("cdt");
		HDD_Assigned.addItem("ddd");
		HDD_Assigned.addItem("c1w");
		HDD_Assigned.addItem("rjg");
		HD_Details.add(HDD_Assigned);
		HDD_Assigned.reshape(520,90,90,20);
		HDD_Assigned.setBackground(new Color(16777215));
		label6 = new java.awt.Label("Problem:",Label.RIGHT);
		label6.reshape(0,115,80,20);
		label6.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label6);
		label9 = new java.awt.Label("Solution:",Label.RIGHT);
		label9.reshape(0,225,80,20);
		label9.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label9);
		horizontalLine1 = new symantec.itools.awt.shape.HorizontalLine();
		horizontalLine1.reshape(5,340,605,2);
		HD_Details.add(horizontalLine1);
		label10 = new java.awt.Label(" Taken By",Label.RIGHT);
		label10.reshape(15,365,80,20);
		label10.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label10);
		label11 = new java.awt.Label(" Assigned",Label.RIGHT);
		label11.reshape(15,385,80,20);
		label11.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label11);
		label12 = new java.awt.Label(" Completed",Label.RIGHT);
		label12.reshape(5,405,90,20);
		label12.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label12);
		HDD_TB_Date = new java.awt.TextField();
		HDD_TB_Date.setEditable(false);
		HDD_TB_Date.reshape(100,365,105,20);
		HDD_TB_Date.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_TB_Date.setBackground(new Color(12632256));
		HD_Details.add(HDD_TB_Date);
		HDD_TB_Time = new java.awt.TextField();
		HDD_TB_Time.setEditable(false);
		HDD_TB_Time.reshape(210,365,65,20);
		HDD_TB_Time.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_TB_Time.setBackground(new Color(12632256));
		HD_Details.add(HDD_TB_Time);
		HDD_TB_Whom = new java.awt.TextField();
		HDD_TB_Whom.setEditable(false);
		HDD_TB_Whom.reshape(280,365,140,20);
		HDD_TB_Whom.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_TB_Whom.setBackground(new Color(12632256));
		HD_Details.add(HDD_TB_Whom);
		label14 = new java.awt.Label(" Date",Label.RIGHT);
		label14.reshape(120,345,50,20);
		label14.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label14);
		label15 = new java.awt.Label(" Time",Label.RIGHT);
		label15.reshape(215,345,45,20);
		label15.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label15);
		label16 = new java.awt.Label(" By Whom",Label.RIGHT);
		label16.reshape(305,345,75,20);
		label16.setFont(new Font("Dialog", Font.BOLD, 10));
		HD_Details.add(label16);
		HDD_AS_Date = new java.awt.TextField();
		HDD_AS_Date.setEditable(false);
		HDD_AS_Date.reshape(100,385,105,20);
		HDD_AS_Date.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_AS_Date.setBackground(new Color(12632256));
		HD_Details.add(HDD_AS_Date);
		HDD_AS_Time = new java.awt.TextField();
		HDD_AS_Time.setEditable(false);
		HDD_AS_Time.reshape(210,385,65,20);
		HDD_AS_Time.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_AS_Time.setBackground(new Color(12632256));
		HD_Details.add(HDD_AS_Time);
		HDD_AS_Whom = new java.awt.TextField();
		HDD_AS_Whom.setEditable(false);
		HDD_AS_Whom.reshape(280,385,140,20);
		HDD_AS_Whom.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_AS_Whom.setBackground(new Color(12632256));
		HD_Details.add(HDD_AS_Whom);
		HDD_CO_Date = new java.awt.TextField();
		HDD_CO_Date.setEditable(false);
		HDD_CO_Date.reshape(100,405,105,20);
		HDD_CO_Date.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_CO_Date.setBackground(new Color(12632256));
		HD_Details.add(HDD_CO_Date);
		HDD_CO_Time = new java.awt.TextField();
		HDD_CO_Time.setEditable(false);
		HDD_CO_Time.reshape(210,405,65,20);
		HDD_CO_Time.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_CO_Time.setBackground(new Color(12632256));
		HD_Details.add(HDD_CO_Time);
		HDD_CO_Whom = new java.awt.TextField();
		HDD_CO_Whom.setEditable(false);
		HDD_CO_Whom.reshape(280,405,140,20);
		HDD_CO_Whom.setFont(new Font("Dialog", Font.BOLD, 10));
		HDD_CO_Whom.setBackground(new Color(12632256));
		HD_Details.add(HDD_CO_Whom);
		HDD_Ok = new java.awt.Button("OK");
		HDD_Ok.reshape(525,360,65,25);
		HDD_Ok.setBackground(new Color(8421504));
		HD_Details.add(HDD_Ok);
		HDD_Cancel = new java.awt.Button("Cancel");
		HDD_Cancel.reshape(525,395,65,25);
		HDD_Cancel.setBackground(new Color(8421504));
		HD_Details.add(HDD_Cancel);
		label18 = new java.awt.Label("< Complete && press TAB");
		label18.reshape(210,25,225,20);
		label18.setFont(new Font("Dialog", Font.BOLD, 10));
		label18.setForeground(new Color(255));
		HD_Details.add(label18);
		HDD_Remove = new java.awt.Button("Remove");
		HDD_Remove.reshape(440,395,65,25);
		HDD_Remove.setBackground(new Color(16756655));
		HD_Details.add(HDD_Remove);
		setTitle("A Dummy Frame to Design the Detail Entry Screen");
		//}}

		//{{INIT_MENUS
		//}}
	    Dimension dim = getToolkit().getScreenSize();
        Rectangle abounds = bounds();
        Dimension dd = size();
        move((dim.width - abounds.width) / 2,
         (dim.height - abounds.height) / 2);
	}

	public HD_Frame1(String title, databaseListener databaselistener, HD_Frame parent) {
	    this();

        this.databaselistener = databaselistener;
        this.parent = parent;
                     
        String dummy = new String();
   	    Today_Date = new String(getDate());
        StringTokenizer st = new StringTokenizer(title, "/");
        UID = st.nextToken();
    	        
	    if (title.startsWith("add")) {
	        Action = "Add";
	        HDD_LogNo.setText("");
	        User_ID = title.substring(4);
            if (User_ID.length() > 13)
                User_ID = User_ID.substring(0, 13);
    	    setTitle("NDP HelpDesk Details: Add (" + User_ID + ")");
    	    HDD_TB_Whom.setText(User_ID);
    	    HDD_TB_Date.setText(Today_Date);
    	    String time = new String(getTime());
    	    HDD_TB_Time.setText(time);
    	        
    	    parent.addOk(false);
       		HD_Details.remove(HDD_Remove);
    	    
    	    if (User_ID.startsWith("User")) {
    	        HDD_Assigned.hide();
	            label17.hide();
    	        HDD_Status.hide();
	            label13.hide();
        		HDD_Assigned.disable();
        		HDD_Status.disable();
        		HDD_Solution.setEditable(false);
    	    }
    	    HDD_LogNo.hide();
	        label1.hide();
	        HDD_Phone.setText("(03) 9565 ");
	    }
	    else {
	        int i = title.indexOf(",");
	        Action = "Query";
	        HDD_LogNo.setText(title.substring(0, i));
	        User_ID = title.substring(i+1);
            if (User_ID.length() > 13)
                User_ID = User_ID.substring(0, 13);
    	    setTitle("NDP HelpDesk Details: Query (" + User_ID + ")");
    	    
    	    if (User_ID.startsWith("User")) {
        		HDD_FirstName.setBackground(new Color(12632256));
        		HDD_Surname.setBackground(new Color(12632256));
        		HDD_Phone.setBackground(new Color(12632256));
        		HDD_Site.setBackground(new Color(12632256));
        		HDD_Assigned.disable();
        		HDD_Status.disable();
        		HDD_Problem.setEditable(false);
        		HDD_Solution.setEditable(false);
        		HD_Details.remove(HDD_Remove);
            }      		
        	HDD_FirstName.setEditable(false);
        	HDD_Surname.setEditable(false);
        	HDD_Phone.setEditable(false);
        	HDD_Site.setEditable(false);
        	label18.hide();
        	
            vdata = databaselistener.processRequest("HELPDESK_CALLLOG_QUERY " + HDD_LogNo.getText());
            data = (String )vdata.elementAt(0);
            if (data.startsWith("ERROR"))
                Phone_Add = true;
            else {
                st = new StringTokenizer(data, "|");
                dummy = st.nextToken();
   	            HDD_Phone.setText(st.nextToken());
   	            HDD_FirstName.setText(st.nextToken());
   	            HDD_Surname.setText(st.nextToken());
   	            HDD_Site.setText(st.nextToken());
   	            
                HDD_Priority.select(st.nextToken());
                HDD_ProbType1.select(st.nextToken());
       	        HDD_Status.select(st.nextToken());
       	        HDD_Assigned.select(st.nextToken());
       	        
       	        HDD_Problem.setText(st.nextToken());
       	        HDD_Solution.setText(st.nextToken());
       	        HDD_TB_Date.setText(st.nextToken());
       	        HDD_TB_Time.setText(st.nextToken());
       	        HDD_TB_Whom.setText(st.nextToken());
       	        HDD_AS_Date.setText(st.nextToken());
       	        HDD_AS_Time.setText(st.nextToken());
       	        HDD_AS_Whom.setText(st.nextToken());       	        
       	        HDD_CO_Date.setText(st.nextToken());
       	        HDD_CO_Time.setText(st.nextToken());
       	        HDD_CO_Whom.setText(st.nextToken());
       	    }
	    }           	
//       	this.repaint();
	}

    public synchronized void show() {
//    	move(50, 50);
    	super.show();
    }

	public boolean handleEvent(Event event) {
		if (event.target == HDD_Assigned && event.id == Event.ACTION_EVENT) {
			HDDAssigned_Action(event);
			return true;
		}
		if (event.target == HDD_Status && event.id == Event.ACTION_EVENT) {
			HDDStatus_Action(event);
			return true;
		}
		if (event.target == HDD_Phone && event.id == Event.LOST_FOCUS) {
			HDDPhone_LostFocus(event);
			return true;
		}
		if (event.target == this && event.id == Event.WINDOW_DESTROY) {
//			HDFrame1_WindowDestroy(event);
	        parent.setPosition();
    	    if (Action.equals("Add"))
         	    parent.addOk(true);
            hide();
			return true;
		}
		if (event.target == HDD_Priority && event.id == Event.ACTION_EVENT) {
			HDDPriority_Action(event);
			return true;
		}
		if (event.target == HDD_Cancel && event.id == Event.ACTION_EVENT) {
	        parent.setPosition();
    	    if (Action.equals("Add"))
         	    parent.addOk(true);
			HDDCancel_Clicked(event);
			return true;
		}
		if (event.target == HDD_Ok && event.id == Event.ACTION_EVENT) {
    	    if (Action.equals("Add"))
         	    parent.addOk(true);
			HDFrame1_Exit(event);
			return true;
		}
		if (event.target == HDD_Remove && event.id == Event.ACTION_EVENT) {
			HDDRemove_Clicked(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	symantec.itools.awt.KeyPressManagerPanel HD_Details;
	java.awt.TextField HDD_LogNo;
	java.awt.Label label1;
	symantec.itools.awt.FormattedTextField HDD_Phone;
	java.awt.Label label3;
	java.awt.TextField HDD_FirstName;
	java.awt.Label label2;
	java.awt.Label label7;
	java.awt.TextField HDD_Surname;
	java.awt.Label label8;
	java.awt.TextField HDD_Site;
	java.awt.Label label5;
	java.awt.Choice HDD_ProbType1;
	java.awt.Label label4;
	java.awt.Choice HDD_Priority;
	java.awt.Label label13;
	java.awt.Choice HDD_Status;
	java.awt.TextArea HDD_Problem;
	java.awt.TextArea HDD_Solution;
	java.awt.Label label17;
	java.awt.Choice HDD_Assigned;
	java.awt.Label label6;
	java.awt.Label label9;
	symantec.itools.awt.shape.HorizontalLine horizontalLine1;
	java.awt.Label label10;
	java.awt.Label label11;
	java.awt.Label label12;
	java.awt.TextField HDD_TB_Date;
	java.awt.TextField HDD_TB_Time;
	java.awt.TextField HDD_TB_Whom;
	java.awt.Label label14;
	java.awt.Label label15;
	java.awt.Label label16;
	java.awt.TextField HDD_AS_Date;
	java.awt.TextField HDD_AS_Time;
	java.awt.TextField HDD_AS_Whom;
	java.awt.TextField HDD_CO_Date;
	java.awt.TextField HDD_CO_Time;
	java.awt.TextField HDD_CO_Whom;
	java.awt.Button HDD_Ok;
	java.awt.Button HDD_Cancel;
	java.awt.Label label18;
	java.awt.Button HDD_Remove;
	//}}

	//{{DECLARE_MENUS
	//}}
}