import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

import symantec.itools.awt.util.dialog.ModalDialog;

public class applicLogin extends ModalDialog {
    int login_ctr = 0;
    public static final int PORT = 5000;
    Socket socket;
    PrintStream svr_out;
    LoginListener listener = null;
    String Application;

    
	void HDLButton1_Clicked(Event event) {
	    String UID = new String(getUserName()),
	           PWD = new String(getPassword());
	  
	    if (UID.equalsIgnoreCase("user")) {
	        UID = "intrauser";
	        PWD = "intraloser";
	    }
	    
// Now send that info off to the DB Server and wait for OK
//    		hide();
        HDL_button1.disable();      // disable the OK button
        if (listener == null) {
            listener = new LoginListener(socket, HDL_statusBar, this, HDL_button1);
        }
        svr_out.println("CONNECT " + UID + " " + PWD + " " + Application);  // send DB request off
	}

	public boolean handleEvent(Event event) {
		if (event.target == HDL_button2 && event.id == Event.ACTION_EVENT) {
		    svr_out.println("quit");
            hide();
		    System.exit(0);
		}
		if (event.target == this && event.id == Event.WINDOW_DESTROY) {
		    svr_out.println("quit");
            hide();
		    System.exit(0);
		}
		if (event.target == HDL_button1 && event.id == Event.ACTION_EVENT) {
			HDLButton1_Clicked(event);
			return true;
		}
		return super.handleEvent(event);
	}

	public applicLogin(Frame parent, String applic)
	{
		super(parent, applic);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 215,insets().top + insets().bottom + 169);
		setBackground(new Color(32896));
		HDL_Panel = new symantec.itools.awt.KeyPressManagerPanel();
		HDL_Panel.setLayout(null);
		HDL_Panel.reshape(insets().left + 0,insets().top + 0,215,170);
		add(HDL_Panel);
		HDL_Label2 = new java.awt.Label("Password:",Label.RIGHT);
		HDL_Label2.reshape(5,55,85,15);
		HDL_Panel.add(HDL_Label2);
		HDL_Label1 = new java.awt.Label("Name:",Label.RIGHT);
		HDL_Label1.reshape(15,15,75,15);
		HDL_Panel.add(HDL_Label1);
		HDL_User = new java.awt.TextField(1);
		HDL_User.setText("User");
		HDL_User.reshape(95,10,100,25);
		HDL_User.setBackground(new Color(16777215));
		HDL_Panel.add(HDL_User);
		HDL_Pwd = new java.awt.TextField(1);
		HDL_Pwd.setEchoCharacter('*');
		HDL_Pwd.setText("****");
		HDL_Pwd.reshape(95,50,100,25);
		HDL_Pwd.setBackground(new Color(16777215));
		HDL_Panel.add(HDL_Pwd);
		HDL_button1 = new java.awt.Button("OK");
		HDL_button1.reshape(40,90,45,25);
		HDL_Panel.add(HDL_button1);
		HDL_button2 = new java.awt.Button("Cancel");
		HDL_button2.reshape(115,90,65,25);
		HDL_Panel.add(HDL_button2);
		HDL_statusBar = new symantec.itools.awt.StatusBar();
		HDL_statusBar.reshape(0,130,215,40);
		HDL_Panel.add(HDL_statusBar);
		HDL_statusBar.setBevelStyle(symantec.itools.awt.StatusBar.BEVEL_NONE);
		setTitle("Help Desk Login");
		//}}

        HDL_Panel.setDefaultButton(HDL_button1);
        HDL_Panel.setCancelButton(HDL_button2);
		this.Application = applic;
		setTitle(applic + " Login");
		
		parent.hide();

        try {
            socket = new Socket("intra", PORT);
            svr_out = new PrintStream(socket.getOutputStream());
        }
        catch (IOException e) {;}

	}
	
	public applicLogin(Frame parent) {
		this(parent, "Username/Password");
	}
	
	// Add a constructor for Interactions (ignoring modal)
	public applicLogin(Frame parent, boolean modal) {
		this(parent);
	}
	
	// Add a constructor for Interactions (ignoring modal)
	public applicLogin(Frame parent, String title, boolean modal) {
		this(parent, title);
	}
	
	public String getUserName() {
		return HDL_User.getText();
	}
	
	public String getPassword() {
		return HDL_Pwd.getText();
	}
	
	public void setUserName(String name) {
		HDL_User.setText(name);
	}
	
	public void setPassword(String pass) {
		HDL_Pwd.setText(pass);
	}
	
	public synchronized void show() {
        Dimension dim = getToolkit().getScreenSize();
        Rectangle abounds = bounds();
        Dimension dd = size();
        move((dim.width - abounds.width) / 2,
         (dim.height - abounds.height) / 2);
        super.show();
        requestFocus();
    }
	
	//{{DECLARE_CONTROLS
	symantec.itools.awt.KeyPressManagerPanel HDL_Panel;
	java.awt.Label HDL_Label2;
	java.awt.Label HDL_Label1;
	java.awt.TextField HDL_User;
	java.awt.TextField HDL_Pwd;
	java.awt.Button HDL_button1;
	java.awt.Button HDL_button2;
	symantec.itools.awt.StatusBar HDL_statusBar;
	//}}
}