import java.awt.*;
import java.awt.Button;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Label;
import java.awt.FlowLayout;
import java.net.URL;
import symantec.itools.multimedia.ImageViewer;
import symantec.itools.awt.util.dialog.ModalDialog;

public class messageDialog extends ModalDialog {

	public boolean handleEvent(Event event) {
		if (event.target == MD_Yes && event.id == Event.ACTION_EVENT) {
			MDYes_Clicked(event);
			return true;
		}
		if (event.target == MD_No && event.id == Event.ACTION_EVENT) {
			MDNo_Clicked(event);
			return true;
		}
		return super.handleEvent(event);
	}

	void MDYes_Clicked(Event event) {
	    Status = "YES";
	    this.closeDialog();
	}

	void MDNo_Clicked(Event event) {
	    Status = "NO";
	    this.closeDialog();
	}

    String Status;

	public messageDialog(Frame parent, String title, String message, URL iconURL) {
		super(parent, title);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 270,insets().top + insets().bottom + 145);
		setBackground(new Color(12632256));
		MD_label = new java.awt.Label("");
		MD_label.reshape(insets().left + 5,insets().top + 5,260,50);
		add(MD_label);
		MD_Yes = new java.awt.Button("Yes");
		MD_Yes.reshape(insets().left + 50,insets().top + 65,60,25);
		MD_Yes.setBackground(new Color(8421504));
		add(MD_Yes);
		MD_No = new java.awt.Button("No");
		MD_No.reshape(insets().left + 150,insets().top + 65,60,25);
		MD_No.setBackground(new Color(8421504));
		add(MD_No);
		setTitle("");
		//}}

		MD_label.setText(message);
		setTitle(title);

		if (iconURL != null) {
			ImageViewer img = new ImageViewer(iconURL);
			add(img);
		}

		Status = "NO";
	}

	public messageDialog(Frame parent) {
		this(parent, "Attention", "Event", null);
	}

    public messageDialog(Frame parent, String title, String message) {
        this(parent, title, message, null);
    }
    
	// Add a constructor for Interactions (ignoring modal)
	public messageDialog(Frame parent, boolean modal) {
		this(parent);
	}

	// Add a constructor for Interactions (ignoring modal)
	public messageDialog(Frame parent, String message, boolean modal) {
		this(parent, "Attention", message, null);
	}
	
	public String getStatus() {
	    return Status;
	}

	//{{DECLARE_CONTROLS
	java.awt.Label MD_label;
	java.awt.Button MD_Yes;
	java.awt.Button MD_No;
	//}}
}